###############################################################################
# ModifyMessage.pl                                                            #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$modifymessageplver = "1 Gold - SP 1.3";

sub ModifyMessage {
	my( $msf, $mfn);
	if($username eq 'Guest') { &fatal_error($txt{'223'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	my( $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, @messages, $curmessage, $msubject, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb);
	$threadid = $INFO{'thread'};
	$postid = int( $INFO{'message'} );

	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$yyThreadLine);
	###Admin Post in Locked Topic Mod###
############## Begin Time Lock mod #################
	if( $mstate == 1 && !exists $moderators{$username} && $settings[7] ne 'Administrator' && $settings[7] ne 'Global Moderator') {
		&fatal_error($txt{'90'});
	} else {
		if ($tlnomodflag == 1) {
			unless ( ( $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' ) || ( exists $moderators{$username} ) ) {
				$tlnomodtimesecs = $tlnomodtime*3600*24;
				$tltime = stringtotime($mdate) + $tlnomodtimesecs;
				$tlcurrenttime = time + (3600*$timeoffset);
				if ( $tlcurrenttime > $tltime ) {
					&fatal_error( "$timelocktxt{'01'}$tlnomodtime$timelocktxt{'02'}" );
				}
			}
		}
	}
############### End Time Lock mod #################
	###Admin Post in Locked Topic Mod###

	if ($INFO{'message'} eq $polltxt{'15'}) {
		unless (-e "$datadir/$threadid.poll") {&fatal_error("$polltxt{'13'}");}

		fopen (FILE, "$datadir/$threadid.poll");
		@poll_data = <FILE>;
		fclose (FILE);
		chomp $poll_data[0];
		($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_choice, $poll_mod, $poll_modname, $poll_comment) = split(/\|/, $poll_data[0]);
		for(my $i = 0; $i < @poll_data; $i++) {
			chomp $poll_data[$i];
			($votes[$i], $options[$i]) = split(/\|/, $poll_data[$i]);
		}

		unless($poll_uname eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') { &fatal_error("$polltxt{'13'}"); }

		$poll_comment =~ s~<br>~\n~g;
		$pollthread = 2;
		$settofield = "question";

	} else {

	fopen(FILE, "$datadir/$threadid.txt") || &fatal_error("$txt{'23'} $threadid.txt");
	@messages = <FILE>;
	fclose(FILE);

	$curmessage = $messages[$postid];
	chomp $curmessage;
	($sub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip,  $message, $mns, $mlm, $mlmb, $mfn) = split(/\|/,$messages[$postid]);

	if($musername ne $username && (!exists $moderators{$username}) && $settings[7] ne 'Administrator' && $settings[7] ne 'Global Moderator' ) {
		&fatal_error($txt{'67'});
	}

	$lastmod = $mlm ? &timeformat($mlm) : '-';
	$nscheck = $mns ? ' checked' : '';

	$lastmod = qq~
<tr>
	<td valign=top width="23%"><font size=2><b>$txt{'211'}:</b></font></td>
	<td><font size="2">$lastmod</font></td>
</tr>
~;
	$icon = $micon;
	if($icon eq "xx") { $ic1 = " selected"; }
	elsif($icon eq "thumbup") { $ic2 = " selected"; }
	elsif($icon eq "thumbdown") { $ic3 = " selected"; }
	elsif($icon eq "exclamation") { $ic4 = " selected"; }
	elsif($icon eq "question") { $ic5 = " selected"; }
	elsif($icon eq "lamp") { $ic6 = " selected"; }
	elsif($icon eq "smiley") { $ic7 = " selected"; }
	elsif($icon eq "angry") { $ic8 = " selected"; }
	elsif($icon eq "cheesy") { $ic9 = " selected"; }
	elsif($icon eq "laugh") { $ic10 = " selected"; }
	elsif($icon eq "sad") { $ic11 = " selected"; }
	elsif($icon eq "wink") { $ic12 = " selected"; }
	$i=0;
	while($MIconURL[$i])
  {
  		if($icon eq $MIconURL[$i])
  		{
  			$ic[$i] = " selected"; }
  		$i++;
  		}

	$message =~ s/<br>/\n/ig;
	$isatt = $mfn;
	chomp $isatt;

		$settofield = "message";
	}
	$submittxt = "$txt{'10'}";
	$destination = "modify2";
	$is_preview = 0;
	$post = "postmodify";
	$preview = "previewmodify";
	require "$sourcedir/Post.pl";
	$yytitle = "$txt{'66'}";
	&Postpage;
	&template;
	exit;
}

sub ModifyMessage2 {
	if($username eq 'Guest') { &fatal_error($txt{'223'}); }
	if( $FORM{'previewmodify'} ) {
		require "$sourcedir/Post.pl";
		&Preview;
	}
	my( $deletepost, $threadid, $postid, @messages, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, @threads, $tmpa, $tmpb, $tnum2, $tdate2, $newlastposttime, $newlastposter, $lastpostid, $views, $name, $email, $subject, $message, $ns, $postkilled, $threadkilled );

###########################################
##  Spikecity's File Attachment Mod V3.0 ##
###########################################

	if ($FORM{'file'} && $FORM{'w_file'} eq "attachnew") {
		$file = $FORM{'file'};
		$OS = $^O; # operating system name
		if($OS =~ /darwin/i) { $isUNIX = 1; }
		elsif($OS =~ /win/i) { $isWIN = 1; }
		else {$isUNIX = 1;}
		$mylimit = 1024 * $limit;
		$mydirlimit = 1024 * $dirlimit;
		$fixfile = $filename;
		$fixfile =~ s/.+\\([^\\]+)$|.+\/([^\/]+)$/$1/;
		$fixfile =~ s/[#%+,\/:?"<>'|@^!]//g;	#edit in between [ ] to include characters you dont want to allow in filenames (dont put a . there or you wont be able to get any file extensions).
		$fixfile =~ s/ /_/g;			#replaces spaces in filenames with a "_" character.

		if($overwrite == 2 && (-e "$upload_dir/$fixfile")){&fatal_error("$fatxt{'8'}");}
		if(!$overwrite){ # if $overwite = 0 or flase, rename file using the checkex sub
			$fixfile = check_existence($upload_dir,$fixfile);
		}
		if ($checkext == 0) { $match = 1; } else {
		foreach $ext (@ext){
			chomp ($ext);
				if (grep /$ext$/i,$fixfile){$match=1; last;}
			}
		}
		if ($match) {
			if ($allowattach == 1 && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) {
				$upload_okay = 1;
			}
		} else {
			&write_error("$fatxt{'20'} @ext ($fixfile)");
		}
		if ($mydirlimit > 0) {
			&dirstats;
		}
		$filesize = $ENV{'CONTENT_LENGTH'} - $postsize;
		$filesizekb = int ($filesize/1024);
		if ($filesize > $mylimit && $mylimit != 0) {
			$filesizediff = $filesizekb - $limit;
			if ($filesizediff == 1) { $sizevar = "kilobyte"; } else { $sizevar = "kilobytes"; }
			&write_error("$fatxt{'21'} $filesizediff $sizevar $fatxt{'21b'}");
		} elsif ($filesize > $spaceleft && $mydirlimit != 0) {
			$filesizediff = $filesizekb - $kbspaceleft;
			if ($filesizediff == 1) { $sizevar = "kilobyte"; } else { $sizevar = "kilobytes"; }
			&write_error("$fatxt{'22'} $filesizediff $sizevar $fatxt{'22b'}");
		}
		$save_file = "$uploadurl/$fixfile";
		if ($upload_okay == 1) {
			# create a new file on the server using the formatted ( new instance ) filename
			if(open(NEWFILE, ">$upload_dir/$fixfile")){
				if($isWIN){binmode NEWFILE;} # if it's a WIN server, switch to binary mode
				# start reading users HD 1 kb at a time.
				while (read($filename, $buffer, 1024)){
					# print each kb to the new file on the server
					print NEWFILE $buffer;
				}
				# close the new file on the server and we're done
				close (NEWFILE);
			} else {
				# return the server's error message if the new file could not be created
				&fatal_error("$fatxt{'60'} $upload_dir");
			}
		}

		# check if file has actually been uploaded, by checking the file has a size
		if(-s "$upload_dir/$fixfile"){
			$upload_ok = 1;
		} else {
			# delete the file as it has no content
			unlink("$upload_dir/$fixfile");
			&fatal_error("$fatxt{'59'} $fixfile");
		}
	}
###########################################
## /Spikecity's File Attachment Mod V3.0 ##
###########################################
	$deletepost = $INFO{'d'} eq '1';
	if($deletepost) {
		$threadid = $INFO{'thread'};
		$postid = $INFO{'id'};
		if ($postid eq $polltxt{'15'} ) {$pollthread = 1;}
	}
	else {
		$threadid = $FORM{'threadid'};
		$postid = $FORM{'postid'};
		$pollthread = $FORM{'pollthread'};
	}

	if ($pollthread) {
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		unless (-e "$datadir/$threadid.poll") {&fatal_error("$polltxt{'13'}");}

		fopen (FILE, "$datadir/$threadid.poll");
		@poll_data = <FILE>;
		fclose (FILE);
		chomp $poll_data[0];
		($poll_question, $poll_locked, $poll_uname, $poll_name, $poll_email, $poll_date, $guest_vote, $hide_results, $multi_choice, $poll_mod, $poll_modname, $poll_comment) = split(/\|/, $poll_data[0]);

		unless($poll_uname eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') { &fatal_error("$polltxt{'13'}"); }

		if ( $deletepost ) { # Delete Poll

			########showcase poll start
			# Look for a showcase.poll file to unlink.
			if (-e "$datadir/showcase.poll") {
				my ($board, $viewnum);
				fopen (FILE, "$datadir/showcase.poll");
				@showdata = <FILE>;
				fclose (FILE);
				$showcasepoll = $showdata[0];
				$showcasepoll =~ s~\n~~g;
				($scboard, $viewnum) = split(/\|/, $showcasepoll);
				if ($viewnum == $threadid) {unlink ("$datadir/showcase.poll");}
			}
			#########showcase poll end
			unlink("$datadir/$threadid.poll");
			unlink("$datadir/$threadid.polled");

		} else { # Modify Poll

			$numcount = 0;
			unless ($FORM{"question"}) { &fatal_error("$polltxt{'37'}"); }
			if ( length($FORM{"question"} ) > $maxpq) { &fatal_error("$polltxt{'40'} $polltxt{'34a'} $maxpq $polltxt{'34b'} $polltxt{'36'}"); }
			$poll_question = $FORM{"question"};
			&ToHTML($poll_question);
			$guest_vote = $FORM{'guest_vote'} || 0;
			$hide_results = $FORM{'hide_results'} || 0;
			$multi_choice = $FORM{'multi_choice'} || 0;
			$poll_comment = $FORM{'poll_comment'} || "";
			if ( length($poll_comment ) > $maxpc) { &fatal_error("$polltxt{'57'} $polltxt{'34a'} $maxpc $polltxt{'34b'} $polltxt{'36'}"); }
			&ToHTML($poll_comment);
			$poll_comment =~ s~\n~<br>~g;
			$poll_comment =~ s~\r~~g;
			my @new_poll_data;
			push @new_poll_data, qq~$poll_question|$poll_locked|$poll_uname|$poll_name|$poll_email|$poll_date|$guest_vote|$hide_results|$multi_choice|$date|$username|$poll_comment\n~;

			for ($i = 1; $i <= $numpolloptions; $i++){
				chomp $poll_data[$i];
				($votes, $dummy) = split(/\|/, $poll_data[$i]);
				if (!$votes) {$votes = "0";}
				if ($FORM{"option$i"}) {
					if (length($FORM{"option$i"}) > $maxpo) { &fatal_error("$polltxt{'7'} $i  $polltxt{'34a'} $maxpo $polltxt{'34b'} $polltxt{'36'}"); }
					&ToHTML($FORM{"option$i"});
					$numcount++;
					push @new_poll_data, qq~$votes|$FORM{"option$i"}\n~;
				}
			}
			if ($numcount < 2) { &fatal_error("$polltxt{'38'}"); }

			fopen (POLL, ">$datadir/$threadid.poll");
			print POLL @new_poll_data;
			fclose (POLL);
		}

		$yySetLocation = qq~$cgi;action=display;num=$threadid~;
		&redirectexit;
	}

	fopen(FILE, "$datadir/$threadid.txt") || &fatal_error("$txt{'23'} $threadid.txt");
	@messages = <FILE>;
	fclose(FILE);


	if ($app_app == 1) { $postid = $app_postid }

	# Make sure the user is allowed to edit this post.
	if( $postid >= 0 && $postid < @messages ) {
		chomp $messages[$postid];
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $mfn) = split( /\|/, $messages[$postid]);
		if($INFO{'d'} eq 1) {
############## Begin Time Lock mod #################
	if ($tlnodelflag == 1) {
		unless ( ( $settings[7] eq 'Administrator'  || $settings[7] eq 'Global Moderator' ) || ( exists $moderators{$username} ) ) {
			$tlnodeltimesecs = $tlnodeltime*3600*24;
			$tldtime = stringtotime($mdate) + $tlnodeltimesecs;
			$tldcurrenttime = time + (3600*$timeoffset);
			if ( $tldcurrenttime > $tldtime ) {
				&fatal_error( "$timelocktxt{'01'}$tlnodeltime$timelocktxt{'02a'}" );
			}
		}
	}
############### End Time Lock mod #################
		}
		else {
			unless($musername eq $username || exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
				&fatal_error("$txt{'67'}");
			}
		}
	}
	else { &fatal_error("$txt{'580'} $postid"); }

	# Look for the current thread in the current board.
	fopen(FILE, "$boardsdir/$currentboard.txt");
	@threads = <FILE>;
	fclose(FILE);
	($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $yyThreadLine );
	$threadnum = $yyThreadPosition;
	###Admin Post in Locked Topic Mod###
	if( $tstate == 1 && !exists $moderators{$username} && $settings[7] ne 'Administrator' && $settings[7] ne 'Global Moderator') {
		&fatal_error($txt{'90'});
	}
	###Admin Post in Locked Topic Mod###

      if( $deletepost ) {
         if (-e "$boardsdir/$currentboard.mbo" ) { require "$boardsdir/$currentboard.mbo"; }
	if ($disablepostcount{$currentboard} != 1 && $musername ne 'Guest') {
			fopen(FILE, "$memberdir/$musername.dat");
			@userprofile = <FILE>;
			fclose(FILE);
			chomp $userprofile[6];
			if ($userprofile[6] > 0)
			{
				--$userprofile[6];
				$userprofile[6] .= "\n";
				fopen(FILE, ">$memberdir/$musername.dat", 1);
				print FILE @userprofile;
				fclose(FILE);
			}
		}
		--$treplies;
		$postkilled = 1;
		if( $treplies < 0 ) {
			# If the post is the only one in the thread, # then delete the thread as well.
			$threads[$threadnum] = '';
			$threadkilled = 1;
			fopen(FILE, "$datadir/$tnum.txt");
			my @amthreadcheck = <FILE>;
			fclose(FILE);
			chomp $amthreadcheck[0];
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $mfn) = split( /\|/, $amthreadcheck[0] );
				if(-e("$upload_dir/$mfn")) {
				fopen(AMV, "$vardir/attachments.txt");
				my @attachments = <AMV>;
				fclose(AMV);
				fopen(AMV, ">$vardir/attachments.txt");
				foreach (@attachments) {
					chomp $_;
					my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
					if($mfn ne $amfn) {
						print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
					}
				}
				fclose(AMV);
			unlink("$upload_dir/$mfn");
			}
			unlink("$datadir/$tnum.txt");
			unlink("$datadir/$tnum.mail");
			unlink("$datadir/$tnum.head");
			unlink("$datadir/$tnum.data");
			if(-e ("$vardir/$tnum.rate")) {
				fopen(FILE, "$vardir/rateslist.txt");
				@ratelist = <FILE>;
				fclose(FILE);
				fopen(FILE, ">$vardir/rateslist.txt", 1);
				foreach $currate (@ratelist) {
					chomp $currate;
					($thiscurrate, $dummy) = split(/\|/, $currate);
					if($thiscurrate ne $tnum) { print FILE "$currate\n"; }
				}
				fclose(FILE);
				unlink("$vardir/$tnum.rate");
			}
			unlink("$datadir/$tnum.poll");
			unlink("$datadir/$tnum.polled");
			&Sticky_remove($tnum);
			
			if( $threadnum == 0 ) {
				($tnum2, $tmpa, $tmpa, $tmpa, $tdate2) = split( /\|/, $threads[1] );
				if( $tnum2 ) {
					$newlastposttime = $tdate2;
					fopen(FILE, "$datadir/$tnum2.data");
					$tmpa = <FILE>;
					@other_stuff = <FILE>;
					fclose(FILE);
					chomp $tmpa;
					($views,$newlastposter) = split(/\|/, $tmpa);
					$newlastthreadid = $tnum2;
				}
				else {
					$newlastposttime = 'N/A';
					$newlastposter = 'N/A';
				}
			}
		}
		else {
			# If the post is not the only one in the thread...
			if( $postid == $#messages ) {
				($tmpa,$tmpa,$tmpa,$tdate) = split( /\|/, $messages[$postid-1] );
			}
			elsif( $postid == 0 ) {
				$_ = $messages[1];
				chomp;
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $mfn) = split( /\|/, $_ );
				$tsub = $msub;
				$ticon = $micon;
			}
			$threads[$threadnum] = qq~$tnum|$tsub|$tname|$temail|$tdate|$treplies|$tusername|$ticon|$tstate\n~;
			if( $postid == $#messages ) {
				# If the post is the last one in the thread, then make sure
				# all the lastposter/lastposttime stuff is correct for the thread.
				$lastpostid = $postid - 1;
				$_ = $messages[$lastpostid];
				chomp;
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $mfn) = split( /\|/, $_ );

				# Changed from->if( $threadnum == 0 ) {
				$newlastposttime = $mdate;
				if($musername ne "Guest") { $newlastposter = $musername; }
				else { $newlastposter = $mname; }

				fopen(FILE, "$datadir/$tnum.data");
				$tmpa = <FILE>;
				@other_stuff = <FILE>;
				fclose(FILE);
				chomp $tmpa;
				($views,$tmpa) = split(/\|/, $tmpa);
				fopen(FILE, "+>$datadir/$tnum.data");
				print FILE qq~$views|$newlastposter~;
				print FILE qq~\n~;
				print FILE @other_stuff;
				fclose(FILE);
			}
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split( /\|/, $messages[$postid] );
				if(-e("$upload_dir/$mfn")) {
				fopen(AMV, "$vardir/attachments.txt");
				my @attachments = <AMV>;
				fclose(AMV);
				fopen(AMV, ">$vardir/attachments.txt");
				foreach (@attachments) {
					chomp $_;
					my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
					if($mfn ne $amfn) {
						print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
					}
				}
				fclose(AMV);
			unlink("$upload_dir/$mfn");
			}
			$messages[$postid] = '';
			# Save thread without the deleted post.
			fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
			print FILE @messages;
			fclose(FILE);
		}
	}
	else {
		# If the post is to be modified...
		$name = $FORM{'name'};
		$email = $FORM{'email'};
		$subject = $FORM{'subject'};
		$message = $FORM{'message'};
		$icon = $FORM{'icon'};
		$ns = $FORM{'ns'};
		&CheckIcon;

		&fatal_error($txt{'78'}) unless($message);
		if (length($message)>$MaxMessLen) { &fatal_error($txt{'499'}); }

		&ToHTML($name);
		$email =~ s/\|//g;
		&ToHTML($email);
		&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~ );
		$message =~ s/\cM//g;
		$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
		$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
		$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
		&ToHTML($message);
		$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
		$message =~ s/\n/<br>/g;
		if ($app_app == 1) {
			$message = $app_message;
			$subject = $app_sub;
		}
		else {
		if( $postid == 0 ) {
			$tsub = $subject;
			$ticon = $icon;
		}
		}
		$threads[$threadnum] = qq~$tnum|$tsub|$tname|$temail|$tdate|$treplies|$tusername|$ticon|$tstate\n~;
		if ( $mip =~ /$user_ip/) {$useredit_ip = $mip;}
		else {$useredit_ip = "$mip $user_ip";}
	if ($FORM{'w_file'} eq "attachnew" && $fixfile) {
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username|$fixfile\n~;
		fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		print FILE @messages;
		fopen(AML, "$vardir/attachments.txt");
		my @attachments = <AML>;
		fclose(AML);
		fopen(AML, ">$vardir/attachments.txt");
		foreach (@attachments) {
			chomp $_;
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
			if($amfn ne $mfn) {
				print AML qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
			}
		}
		print AML qq~$threadid|$treplies|$subject|$musername|$currentboard|$filesizekb|$date|$fixfile\n~;
		fclose(AML);
		unlink("$upload_dir/$mfn");
	} elsif ($FORM{'w_file'} eq "attachold") {
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username|$mfn\n~;
		fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		print FILE @messages;
		fclose(FILE);
	} elsif ($FORM{'w_file'} eq "attachnew" && !$fixfile) {
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username|$mfn\n~;
		fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		print FILE @messages;
		fclose(FILE);
	} elsif ($FORM{'w_file'} eq "attachdel" && -e("$upload_dir/$mfn")) {
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username|\n~;
		fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		print FILE @messages;
		fopen(AML, "$vardir/attachments.txt");
		my @attachments = <AML>;
		fclose(AML);
		fopen(AML, ">$vardir/attachments.txt");
		foreach (@attachments) {
			chomp $_;
			my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$_);
			if($amfn ne $mfn) {
				print AML qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
			}
		}
		unlink("$upload_dir/$mfn");
		fclose(FILE);
	} elsif ($FORM{'w_file'} eq "attachdel" && !-e("$upload_dir/$mfn")) {
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username|\n~;
		fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		print FILE @messages;
		fclose(FILE);
	} else {
		$messages[$postid] = qq~$subject|$mname|$memail|$mdate|$musername|$icon|0|$useredit_ip|$message|$ns|$date|$username|$mfn\n~;
		fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		print FILE @messages;
		fclose(FILE);
	}
		fopen(FILE, ">$datadir/$threadid.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		print FILE @messages;
		fclose(FILE);
	}
	# Save the current board.
	fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("$txt{'23'} $currentboard.txt");
		seek FILE, 0, 0;
		my @buffer = <FILE>;
		truncate FILE, 0;
		for ($a = 0; $a < @buffer; $a++) {
			if ( $buffer[$a] =~ m~\A$threadid\|~o ) { $buffer[$a] = $threads[$threadnum]; last; }
		}
		seek FILE, 0, 0;
		print FILE @buffer;
	fclose(FILE);

	if( $postkilled ) {
		# If post was killed, update the current board.
		my( $threadcount, $messagecount, $lastposttime, $lastposter, $lastthreadid ) = &BoardCountGet($currentboard);
		--$messagecount;
		if( $threadkilled ) {
			--$threadcount;
		}
		if ($newlastposttime eq "N/A") { $lastthreadid = ""; }
		&BoardCountSet( $currentboard, $threadcount, $messagecount, $newlastposttime || $lastposttime, $newlastposter || $lastposter, $newlastthreadid || $lastthreadid );
	}

	&dumplog($currentboard);
	if( $threadkilled ) {
		$yySetLocation = qq~$cgi~;
		&redirectexit;
	}
	else {
		# Let's figure out what page number to show
		my $pageindex = int($postid / $maxmessagedisplay);
		my $start = $pageindex * $maxmessagedisplay;
		$yySetLocation = qq~$cgi;action=display;num=$threadid;start=$start#$postid~;
		&redirectexit;
	}
}

sub MultiDel {
	$yySetLocation = qq~$cgi;action=display;num=$INFO{'thread'};start=$INFO{'start'}~;
	$mkill = 0;
	$topickill = 0;
	fopen(FILE, "$datadir/$INFO{'thread'}.txt", 1) || &fatal_error("$txt{'23'} $INFO{'thread'}.txt");
		@mess = <FILE>;
	fclose(FILE);
	$count = $#mess;
	$tnum = $INFO{'thread'};

	fopen(AMV, "$vardir/attachments.txt");
		my @attachments = <AMV>;
	fclose(AMV);

	# Find thread position in message index
	fopen(FILE, "$boardsdir/$currentboard.txt");
		@threads = <FILE>;
	fclose(FILE);
	$tmpcount = 0;
	$threadpos = '';
	foreach $curentry (@threads) {
		($tmpa, $dummy) = split(/\|/, $curentry);
		if($INFO{'thread'} eq $tmpa) { $threadpos = $tmpcount; }
		$tmpcount++;
	}

	# check all checkboxes, delete posts if checkbox is ticked
	while (0 <= $count) {
		if ($FORM{"del$count"} ne '' && $threadpos ne ''){
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split( /\|/, $mess[$count] );
			chomp $mfn;
			if(-e("$upload_dir/$mfn")) { 
				$attachpos = $#attachments;
				while (0 <= $attachpos) {
					my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$attachments[$attachpos]);
					chomp $amfn;
					if($tnum eq $amthreadid) {
						if($amreplies eq $count) {
							splice(@attachments, $attachpos, 1);
						} elsif ($amreplies > $count) {
							$amreplies--;
							$attachments[$attachpos] = "$amthreadid|$amreplies|$amthreadsub|$amposter|$currentboard|$amkb|$amdate|$amfn\n";
						}
					}
					$attachpos--;
				}
				unlink("$upload_dir/$mfn"); 
			}

			if ($mess[1] eq '' || $mess[1] eq "\n"){
				# if this is the only post, delete the files
				unlink("$datadir/$tnum.txt");
				unlink("$datadir/$tnum.mail");
				unlink("$datadir/$tnum.data");
				unlink("$datadir/$tnum.poll");
				unlink("$datadir/$tnum.polled");
				unlink("$datadir/$tnum.polll");
				splice(@threads, $threadpos, 1);
				$topickill = 1;
				$yySetLocation = qq~$cgi~;
			} else { 
				# if this is not the only post, delete post
				splice(@mess, $count, 1);
				$mkill++;
			}
		}
		$count--;
	}

	# if thread has not been deleted from message index, update message index details
	($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb) = split( /\|/, $mess[$#mess]);

	if ($topickill != 1 && $threadpos ne ''){
		($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$threadpos] );
		$treplies = $treplies - $mkill;
		$threads[$threadpos] = qq~$tnum|$tsub|$tname|$temail|$mdate|$treplies|$tusername|$ticon|$tstate~;

		# Save updated posts
		fopen(FILE, ">$datadir/$INFO{'thread'}.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
			print FILE @mess;
		fclose(FILE);

		# Update last poster information
		if( -e "$datadir/$INFO{'thread'}.data" ) {
			fopen(FILE, "$datadir/$INFO{'thread'}.data"); 
			$tmpa = <FILE>;
			fclose(FILE);
			($views,$dummy) = split(/\|/, $tmpa);
			fopen(FILE, "+>$datadir/$INFO{'thread'}.data");
			print FILE qq~$views|$musername~;
			fclose(FILE);
		}
	}

	# Save updated attachments file
	fopen(FILE, ">$vardir/attachments.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		foreach $row(@attachments) {



			chomp $row;
			print FILE qq~$row\n~;
		}
	fclose(FILE);

	# Save updated message index
	fopen(FILE, ">$boardsdir/$currentboard.txt", 1) || &fatal_error("$txt{'23'} $currentboard.txt");
		print FILE @threads;
	fclose(FILE);

	# update board index details
	($latestnum, $dummy) = split( /\|/, $threads[0] );
	fopen(FILE, "$datadir/$latestnum.txt", 1) || &fatal_error("$txt{'23'} $latestnum.txt");
		@mess = <FILE>;
	fclose(FILE);
	($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb) = split( /\|/, $mess[$#mess]);
	my( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($currentboard);
	$messagecount = $messagecount - $mkill;
	if( $topickill == 1) {
		--$threadcount;
		--$messagecount;
	}
	&BoardCountSet( $currentboard, $threadcount, $messagecount, $mdate, $musername );
	&redirectexit;
}
sub MultiDel {
	$yySetLocation = qq~$cgi;action=display;num=$INFO{'thread'};start=$INFO{'start'}~;
	$mkill = 0;
	$topickill = 0;
	fopen(FILE, "$datadir/$INFO{'thread'}.txt", 1) || &fatal_error("$txt{'23'} $INFO{'thread'}.txt");
		@mess = <FILE>;
	fclose(FILE);
	$count = $#mess;
	$tnum = $INFO{'thread'};

	fopen(AMV, "$vardir/attachments.txt");
		my @attachments = <AMV>;
	fclose(AMV);

	# Find thread position in message index
	fopen(FILE, "$boardsdir/$currentboard.txt");
		@threads = <FILE>;
	fclose(FILE);
	$tmpcount = 0;
	$threadpos = '';
	foreach $curentry (@threads) {
		($tmpa, $dummy) = split(/\|/, $curentry);
		if($INFO{'thread'} eq $tmpa) { $threadpos = $tmpcount; }
		$tmpcount++;
	}

	# check all checkboxes, delete posts if checkbox is ticked
	while (0 <= $count) {
		if ($FORM{"del$count"} ne '' && $threadpos ne ''){
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb, $msf, $mfn) = split( /\|/, $mess[$count] );
			chomp $mfn;
			if(-e("$upload_dir/$mfn")) { 
				$attachpos = $#attachments;
				while (0 <= $attachpos) {
					my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$attachments[$attachpos]);
					chomp $amfn;
					if($tnum eq $amthreadid) {
						if($amreplies eq $count) {
							splice(@attachments, $attachpos, 1);
						} elsif ($amreplies > $count) {
							$amreplies--;
							$attachments[$attachpos] = "$amthreadid|$amreplies|$amthreadsub|$amposter|$currentboard|$amkb|$amdate|$amfn\n";
						}
					}
					$attachpos--;
				}
				unlink("$upload_dir/$mfn"); 
			}

			if ($mess[1] eq '' || $mess[1] eq "\n"){
				# if this is the only post, delete the files
				unlink("$datadir/$tnum.txt");
				unlink("$datadir/$tnum.mail");
				unlink("$datadir/$tnum.data");
				unlink("$datadir/$tnum.poll");
				unlink("$datadir/$tnum.polled");
				unlink("$datadir/$tnum.polll");
				splice(@threads, $threadpos, 1);
				$topickill = 1;
				$yySetLocation = qq~$cgi~;
			} else { 
				# if this is not the only post, delete post
				splice(@mess, $count, 1);
				$mkill++;
			}
		}
		$count--;
	}

	# if thread has not been deleted from message index, update message index details
	($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb) = split( /\|/, $mess[$#mess]);

	if ($topickill != 1 && $threadpos ne ''){
		($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$threadpos] );
		$treplies = $treplies - $mkill;
		$threads[$threadpos] = qq~$tnum|$tsub|$tname|$temail|$mdate|$treplies|$tusername|$ticon|$tstate~;

		# Save updated posts
		fopen(FILE, ">$datadir/$INFO{'thread'}.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
			print FILE @mess;
		fclose(FILE);

		# Update last poster information
		if( -e "$datadir/$INFO{'thread'}.data" ) {
			fopen(FILE, "$datadir/$INFO{'thread'}.data"); 
			$tmpa = <FILE>;
			fclose(FILE);
			($views,$dummy) = split(/\|/, $tmpa);
			fopen(FILE, "+>$datadir/$INFO{'thread'}.data");
			print FILE qq~$views|$musername~;
			fclose(FILE);
		}
	}

	# Save updated attachments file
	fopen(FILE, ">$vardir/attachments.txt", 1) || &fatal_error("$txt{'23'} $threadid.txt");
		foreach $row(@attachments) {



			chomp $row;
			print FILE qq~$row\n~;
		}
	fclose(FILE);

	# Save updated message index
	fopen(FILE, ">$boardsdir/$currentboard.txt", 1) || &fatal_error("$txt{'23'} $currentboard.txt");
		print FILE @threads;
	fclose(FILE);

	# update board index details
	($latestnum, $dummy) = split( /\|/, $threads[0] );
	fopen(FILE, "$datadir/$latestnum.txt", 1) || &fatal_error("$txt{'23'} $latestnum.txt");
		@mess = <FILE>;
	fclose(FILE);
	($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns, $mlm, $mlmb) = split( /\|/, $mess[$#mess]);
	my( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($currentboard);
	$messagecount = $messagecount - $mkill;
	if( $topickill == 1) {
		--$threadcount;
		--$messagecount;
	}
	&BoardCountSet( $currentboard, $threadcount, $messagecount, $mdate, $musername );
	&redirectexit;
}
1;
